package b4a.flm.overlaywdw;

import android.content.Intent;
import android.net.Uri;
import android.os.Build;
import android.provider.Settings;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.IOnActivityResult;

@BA.ShortName("OverlayPermission")
@BA.Events(values = {
		"DrawPermission(Allowed As Boolean)"
})
public class OverlayPermission
{
	IOnActivityResult iOnActivityResult;

	/** Requests the permission to draw overlays over applications for Android versions >= 23. Returns whether a permission is required or not. */
	public boolean RequestPermission(final BA ba, final String EventPrefix)
	{
		if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M && !Settings.canDrawOverlays(ba.context)) {
			Intent intent = new Intent(Settings.ACTION_MANAGE_OVERLAY_PERMISSION, Uri.parse("package:" + BA.applicationContext.getPackageName()));
			iOnActivityResult = new IOnActivityResult() {
				@Override
				public void ResultArrived(int resultCode, Intent intent) {
					ba.raiseEvent(this, EventPrefix.toLowerCase(BA.cul) + "_drawpermission", new Object[] { Settings.canDrawOverlays(ba.context) });
				}
			};
			ba.startActivityForResult(iOnActivityResult, intent);
			return true;
		}
		return false;
	}

	/** Returns whether this application is allowed to draw overlays over applications. */
	public boolean IsAllowed(BA ba)
	{
		return (Build.VERSION.SDK_INT < Build.VERSION_CODES.M || Settings.canDrawOverlays(ba.context));
	}
}
