﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=6.5
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim MyNotification As Notification
	Dim MyOverlayWindow As OverlayWindow
	Dim MyBitmap As Bitmap
	Dim InitialPosX, InitialPosY As Int
End Sub

Sub Service_Create
	
	MyBitmap.Initialize(File.DirAssets, "BG.png")
	InitWindow
	
	MyNotification.Initialize
	MyNotification.Icon = "icon"
	MyNotification.OnGoingEvent = True
	MyNotification.Sound = False
	MyNotification.Vibrate = False
	MyNotification.SetInfo("Return to MainActivity。", "", Main)

End Sub

Sub Service_Start (StartingIntent As Intent)														'Starter service can start in the foreground state in some edge cases.
	Service.StopAutomaticForeground																
End Sub

Sub Service_TaskRemoved																				'This event will be raised when the user removes the app from the recent apps list.
	StopWorking																							
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy
	StopWorking
End Sub

Sub StartWorking
	Service.StartForeground(1, MyNotification)
	ShowWindow
End Sub

Sub StopWorking
	If MyOverlayWindow.IsInitialized Then
		MyOverlayWindow.Close
	End If
End Sub

Sub InitWindow
	
	MyOverlayWindow.Initialize2(100, 100, 400, 400, "MyOverlayPanel")
	
	Dim MyOverlayPanel As Panel = MyOverlayWindow.Panel
	MyOverlayPanel.Color = Colors.ARGB(0, 255, 255, 255)
	MyOverlayPanel.SetBackgroundImage(MyBitmap)
End Sub

Sub ShowWindow
	If Not(MyOverlayWindow.IsOpen) Then
		MyOverlayWindow.Open
	End If
	MyOverlayWindow.Visible = True
End Sub


Sub MyOverlayPanel_onTouch(Action As Int, X As Float, Y As Float, ScreenX As Float, ScreenY As Float, MotionEvent As Object) As Boolean
	Log("onTouch action=" & Action & ", X = " & X & ", Y = " & Y & ", ScreenX = " & ScreenX & ", ScreenY = " & ScreenY & ", Event = " & MotionEvent)
	Return True 'True = Handle this touch event, False = Ignore it
End Sub

Sub MyOverlayPanel_onDown(X As Float, Y As Float, MotionEvent As Object)
	InitialPosX = X
	InitialPosY = Y
	Log("   *onDown X = " & X & ", Y = " & Y & ", Event = " & MotionEvent)
End Sub

Sub MyOverlayPanel_onPointerDown(ptrIndex As Int, PID As Int, MotionEvent As Object)
	Log("*onPointerDown ptrindex=" & ptrIndex & ", pid=" & PID & ", Event = " & MotionEvent)
End Sub

Sub MyOverlayPanel_onPointerUp(ptrIndex As Int, PID As Int, MotionEvent As Object)
	Log("*onPointerUp ptrindex=" & ptrIndex & ", pid=" & PID & ", Event = " & MotionEvent)
End Sub

Sub MyOverlayPanel_onPinchOpen(NewDistance As Float, PreviousDistance As Float, MotionEvent As Object)
	Log("   *onPinchOpen dist=" & NewDistance & ", prevdist=" & PreviousDistance & ", Event = " & MotionEvent)
End Sub

Sub MyOverlayPanel_onPinchClose(NewDistance As Float, PreviousDistance As Float, MotionEvent As Object)
	Log("   *onPinchClose dist=" & NewDistance & ", prevdist=" & PreviousDistance & ", Event = " & MotionEvent)
End Sub

Sub MyOverlayPanel_onRotation(Degrees As Double, MotionEvent As Object)
	Log("   *onRotation degrees=" & Degrees & ", Event = " & MotionEvent)
End Sub

Sub MyOverlayPanel_onSingleTapUp(X As Float, Y As Float, MotionEvent As Object)
	Log("   *onSingleTapUp Xx = " & X & ", Y = " & Y & ", ev = " & MotionEvent)
End Sub

Sub MyOverlayPanel_onSingleTapConfirmed(X As Float, Y As Float, MotionEvent As Object)
	Log("   *onSingleTapConfirmed X = " & X & ", Y = " & Y & ", Event = " & MotionEvent)
	ToastMessageShow("Single-Tap", False)
End Sub

Sub MyOverlayPanel_onDoubleTap(X As Float, Y As Float, MotionEvent As Object)
	Log("   *onDoubleTap x = " & X & ", y = " & Y & ", Event = " & MotionEvent)
	ToastMessageShow("Double-Tap", False)
End Sub
Sub MyOverlayPanel_onShowPress(X As Float, Y As Float, MotionEvent As Object)
	Log("   *onShowPress x=" & X & ", y=" & Y & ", Event = " & MotionEvent)
End Sub

Sub MyOverlayPanel_onLongPress(X As Float, Y As Float, MotionEvent As Object)
	Log("   *onLongPress x=" & X & ", y=" & Y & ", Event = " & MotionEvent)
	ToastMessageShow("Long Press", False)
End Sub

Sub MyOverlayPanel_onDrag(DeltaX As Float, DeltaY As Float, ScreenX As Float, ScreenY As Float, MotionEvent As Object)
	Log("   onDrag DeltaX = " & DeltaX & ", DeltaY = " & DeltaY & ", ScreenX = " & ScreenX & ", ScreenY = " & ScreenY & ", ev = " & MotionEvent)
	MyOverlayWindow.SetPosition(ScreenX - InitialPosX, ScreenY - InitialPosY)
	Log(ScreenX & "    " & ScreenY)
End Sub

Sub MyOverlayPanel_onScroll(distanceX As Float, distanceY As Float, MotionEvent1 As Object, MotionEvent2 As Object)
	Log("   *onScroll distanceX = " & distanceX & ", distanceY = " & distanceY & ", Event1 = " & MotionEvent1 & ", Event2=" & MotionEvent2)
End Sub

Sub MyOverlayPanel_onFling(velocityX As Float, velocityY As Float, MotionEvent1 As Object, MotionEvent2 As Object)
	Log("   *onFling velocityX = " & velocityX & ", velocityY = " & velocityY & ", Event1 = " & MotionEvent1 & ", Event2 = " & MotionEvent2)
	ToastMessageShow("Fling", False)
End Sub
